// LuaColouriser.cpp : Implementation of CLuaColouriser

#include "stdafx.h"
#include "LuaColouriser.h"


// CLuaColouriser

void CLuaColouriser::SetTextLines( CComPtr<IVsTextLines> const& buffer )
{
	m_buffer = buffer;
}

STDMETHODIMP CLuaColouriser::GetStateMaintenanceFlag( BOOL *flag )
{
	// check argument
	if( !flag )
		return E_INVALIDARG;

	// we require per-line maintenance
	*flag = TRUE;
	return S_OK;
}

STDMETHODIMP CLuaColouriser::GetStartState( long *state )
{
	// check argument
	if( !state )
		return E_INVALIDARG;

	// our start state is 0
	*state = 0;
	return S_OK;
}

STDMETHODIMP_(long) CLuaColouriser::ColorizeLine( long /*line*/, long length, WCHAR const *text, long state, ULONG *attributes )
{
	// scan the line
	int newState = m_scanner.ScanBuffer( text, length, state );
	
	// copy the attributes
	memcpy( attributes, m_scanner.GetTypes(), ( length + 1 )*sizeof( int ) );
		
	// return the new state
	return newState;
}

STDMETHODIMP_(long) CLuaColouriser::GetStateAtEndOfLine( long /*line*/, long length, WCHAR const* text, long state )
{
	// scan the line
	int newState = m_scanner.ScanBuffer( text, length, state );
	
	// return the new state
	return newState;
}

STDMETHODIMP_(void) CLuaColouriser::CloseColorizer()
{
	// release the buffer
	m_buffer.Release();
}
