// LuaColouriser.h : Declaration of the CLuaColouriser

#pragma once
#include "resource.h"       // main symbols

#include "LuaLite.h"
#include <textmgr.h>
#include "LuaScanner.h"


// CLuaColouriser

class ATL_NO_VTABLE CLuaColouriser : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLuaColouriser>,
	public IVsColorizer
{
public:
	CLuaColouriser()
	{
	}

BEGIN_COM_MAP( CLuaColouriser )
	COM_INTERFACE_ENTRY( IVsColorizer )
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	void SetTextLines( CComPtr<IVsTextLines> const& buffer );

	// IVsColorizer
	STDMETHODIMP GetStateMaintenanceFlag( BOOL *flag );
	STDMETHODIMP GetStartState( long *state );
	STDMETHODIMP_(long) ColorizeLine( long line, long length, WCHAR const *text, long state, ULONG *attributes );
	STDMETHODIMP_(long) GetStateAtEndOfLine( long line, long length, WCHAR const* text, long state );
	STDMETHODIMP_(void) CloseColorizer();

private:
	CComPtr<IVsTextLines> m_buffer;
	LuaScanner m_scanner;
};
