// LuaFilter.h : Declaration of the CLuaFilter

#pragma once
#include "resource.h"       // main symbols

#include <docobj.h>
#include <textmgr.h>
#include <string>
#include <vector>

// CLuaFilter

class ATL_NO_VTABLE CLuaFilter : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLuaFilter>,
	public IOleCommandTarget, 
	public IVsCompletionSet
{
public:
	CLuaFilter()
	{
	}

BEGIN_COM_MAP( CLuaFilter )
	COM_INTERFACE_ENTRY( IOleCommandTarget )
	COM_INTERFACE_ENTRY( IVsCompletionSet )
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	HRESULT Attach( CComPtr<IVsTextView> const& view );
	void Detach();

	// IOleCommandTarget
    STDMETHODIMP QueryStatus( GUID const* commandGroup, ULONG commandCount, OLECMD commands[], OLECMDTEXT* commandText);
    STDMETHODIMP Exec( GUID const* commandGroup, DWORD commandID, DWORD options, VARIANT* varIn, VARIANT* varOut );

	// IVsCompletionSet
	STDMETHODIMP_( DWORD ) GetFlags();
	STDMETHODIMP_( long ) GetCount();
	STDMETHODIMP GetDisplayText( long index, WCHAR const** text, long* glyph );
	STDMETHODIMP GetImageList( HANDLE* images );
	STDMETHODIMP GetDescriptionText( long index, BSTR* description );
	STDMETHODIMP GetInitialExtent( long* line, long* startCol, long *endCol );
	STDMETHODIMP GetBestMatch( WCHAR const* soFar, long length, long* index, DWORD* flags );
	STDMETHODIMP OnCommit( WCHAR const *soFar, long index, BOOL selected, WCHAR commit, BSTR* completeWord );
	STDMETHODIMP_( void ) Dismiss();


private:
	void ResetList();

	CComPtr<IVsTextView> m_view;
	CComPtr<IOleCommandTarget> m_next;
	std::vector<std::wstring> m_identifiers;
};
