// LuaLitePackage.h : Declaration of the CLuaLitePackage

#pragma once
#include "resource.h"       // main symbols

#include "LuaLite.h"
#include <vssplash.h>


// CLuaLitePackage

class ATL_NO_VTABLE CLuaLitePackage : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLuaLitePackage, &CLSID_LuaLitePackage>,
	public IVsPackage, 
	public IServiceProvider, 
	public IVsInstalledProduct
{
public:
	CLuaLitePackage()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_LUALITEPACKAGE)

BEGIN_COM_MAP( CLuaLitePackage )
	COM_INTERFACE_ENTRY( IVsPackage )
	COM_INTERFACE_ENTRY( IServiceProvider )
	COM_INTERFACE_ENTRY( IVsInstalledProduct )
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	// IVsPackage
	STDMETHODIMP SetSite( IServiceProvider *serviceProvider );
	STDMETHODIMP QueryClose( BOOL *canClose );
	STDMETHODIMP Close();
	STDMETHODIMP GetAutomationObject( LPCOLESTR propName, IDispatch **dispatch );
	STDMETHODIMP CreateTool( REFGUID persistenceSlot );
	STDMETHODIMP ResetDefaults( PKGRESETFLAGS flags );
	STDMETHODIMP GetPropertyPage( REFGUID pageID, VSPROPSHEETPAGE *page );

	// IServiceProvider
	STDMETHODIMP QueryService( REFGUID serviceID,  REFIID riid,  void **object );

	// IVsInstalledProduct
	STDMETHODIMP get_IdBmpSplash( UINT* bmpID );
	STDMETHODIMP get_OfficialName( BSTR* officialName );
	STDMETHODIMP get_ProductID( BSTR* productID );
	STDMETHODIMP get_ProductDetails( BSTR* productDetails );
	STDMETHODIMP get_IdIcoLogoForAboutbox( UINT* bmpID );
};

OBJECT_ENTRY_AUTO(__uuidof(LuaLitePackage), CLuaLitePackage)
