// LuaWindowManager.h : Declaration of the CLuaWindowManager

#pragma once
#include "resource.h"       // main symbols

#include "LuaLite.h"
#include <textmgr.h>
#include <list>
#include <docobj.h>

// CLuaWindowManager

class ATL_NO_VTABLE CLuaWindowManager : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLuaWindowManager>,
	public IVsCodeWindowManager
{
public:
	CLuaWindowManager()
	{
	}

BEGIN_COM_MAP( CLuaWindowManager )
	COM_INTERFACE_ENTRY( IVsCodeWindowManager )
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	void SetWindow( CComPtr<IVsCodeWindow> const& window ) { m_window = window; }

	// IVsCodeWindowManager
    STDMETHODIMP AddAdornments();
    STDMETHODIMP RemoveAdornments();
    STDMETHODIMP OnNewView( IVsTextView* view );

private:
	typedef std::list<CAdapt<CComPtr<IOleCommandTarget> > > TargetList;

	CComPtr<IVsCodeWindow> m_window;
	TargetList m_targets;
};
